"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function seedOfNow() {
    return Date.now() >>> 0;
}
exports.seedOfNow = seedOfNow;
class Random {
    constructor(seed = seedOfNow()) {
        // XorShift
        this._x = 123456789;
        this._y = 362436069;
        this._z = 521288629;
        this._w = seed >>> 0;
    }
    nextUInt32() {
        const { _x, _w } = this;
        let t = _x ^ (_x << 11);
        this._x = this._y;
        this._y = this._z;
        this._z = _w;
        return (this._w = (_w ^ (_w >>> 19)) ^ (t ^ (t >>> 8))) >>> 0;
    }
    /**
     * [0..1)
     */
    next() {
        return this.nextUInt32() / 4294967295 /* Max */;
    }
    /**
     * [min...max)
     */
    range(min, max) {
        if (max < min) {
            throw new Error(`min /* ${min} */ < max /* ${max} */`);
        }
        const lo = Math.min(min, max);
        const hi = Math.max(min, max);
        return lo + this.next() * (hi - lo);
    }
}
exports.Random = Random;
//# sourceMappingURL=random.js.map